<!-- 视频列表 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <el-button type="primary" @click="handleAdd"> 添加 </el-button>
        </div>
        <ProTable
            ref="proTableRef"
            :formData="dataStore.formData"
            :columns="dataStore.columns"
            :request-api="getBannerClassListApi"
            :init-param="dataStore.initParam"
        >
            <template #image="scope">
                <el-image :src="scope.row.image ? h + scope.row.image : ''" style="width: 60px; height: 60px" />
            </template>
            <template #status="scope">
                <el-tag type="success" effect="dark">{{ scope.row.status }}</el-tag>
            </template>
            <template #operation="scope">
                <el-button size="small" type="primary" @click="getBannerClassListRead(scope.row.id)">编辑</el-button>
                <el-button size="small" type="danger" @click="getBannerClassListDel(scope.row.id)">删除</el-button>
            </template>
        </ProTable>
        <el-drawer
            v-model="dataStore.visible"
            :show-close="true"
            :size="600"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="handleBeforeClone"
            destroy-on-close
        >
            <template #header="{ titleId, titleClass }">
                <h4 :id="titleId" :class="titleClass">{{ dataStore.title }}</h4>
            </template>
            <div>
                <rulesForm
                    :ruleForm="dataStore.editRuleForm"
                    :formData="dataStore.editFormData"
                    :rules="dataStore.rules"
                    ref="formRef"
                />
            </div>
            <!--  @handleRadioGroupEmits="handleRadioGroupEmits" -->
            <template #footer>
                <div style="flex: auto">
                    <el-button @click="handleResetClick">重置</el-button>
                    <el-button type="primary" @click="handleConfirmClick">确认</el-button>
                </div>
            </template>
        </el-drawer>
    </div>
</template>

<script setup lang="ts" name="bannerClassListIndex">
import ProTable from "@/components/ProTable/index.vue";
import rulesForm from "@/components/rulesForm/index.vue";
import { messageBox } from "@/utils/messageBox";
import { useMsg } from "@/hooks/useMsg";
import { h } from "@/utils/url";
//列表接口
import {
    getBannerClassListApi,
    getBannerClassListDelApi,
    getBannerClassListReadApi,
    getBannerClassListUpApi,
    getBannerClassListSaveApi
} from "@/api/modules/bannerClass";
//深拷贝方法
import { cloneDeep } from "lodash-es";
//表格和搜索條件
import { RULE_FORM, FORM_DATA, COLUMNS, EDIT_FORM_DATA, EDIT_RULE_FORM, RULES } from "./constant/index";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTableRef = ref<any>(null);
const formRef: any = ref(null);
// 数据源
const dataStore = reactive<any>({
    title: "添加Banner分类",
    columns: COLUMNS, //列表配置项
    rules: cloneDeep(RULES), //抽屉表单验证
    editRuleForm: cloneDeep(EDIT_RULE_FORM),
    editFormData: cloneDeep(EDIT_FORM_DATA), //抽屉表单配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索參數
    formData: FORM_DATA, //搜索配置项
    visible: false
});

//抽屉确认
const handleConfirmClick = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef!.validate((valid: any) => {
        if (valid) {
            dataStore.title === "添加Banner分类" ? getBannerClassListSave() : getBannerClassListUp();
            console.log("submit!");
        } else {
            console.log("error submit!");
            return false;
        }
    });
};

// const handleRadioGroupEmits = (value: any) => {
//     // if (value === "image") {
//     //       dataStore.editFormData = EDIT_FORM_DATA;
//     //       dataStore.rules = RULES;
//     //   } else {
//     //       dataStore.editFormData = EDIT_FORM_DATA1;
//     //       dataStore.rules = RULES1;
//     //   }
//     console.log(value, "=========value============");
// };

//重置验证状态
const resetFields = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef.resetFields();
};
//抽屉重置
const handleResetClick = () => {
    if (dataStore.title === "添加Banner分类") {
        resetFields();
    } else {
        getBannerClassListRead(dataStore.editRuleForm.id);
    }
};
//添加
const handleAdd = () => {
    dataStore.visible = true;
    dataStore.title = "添加Banner分类";
};
const handleBeforeClone = () => {
    dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
    resetFields();
    dataStore.visible = false;
};
//更新
const getBannerClassListUp = async () => {
    const result = await getBannerClassListUpApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        formRef!.value!.ruleFormRef.resetFields();
        proTableRef?.value?.getTableList();
    }
};
//新增 getBannerListSave
const getBannerClassListSave = async () => {
    const result = await getBannerClassListSaveApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        formRef!.value!.ruleFormRef.resetFields();
        proTableRef?.value?.getTableList();
    }
};
//删除
const getBannerClassListDel = async (id: any) => {
    messageBox("你确定要删除?", async () => {
        const result = await getBannerClassListDelApi(id);
        if (result?.code === 0) {
            const { msg } = result;
            useMsg("success", msg);
            proTableRef?.value?.getTableList();
        }
    });
};
//详情
const getBannerClassListRead = async (id: any) => {
    dataStore.title = "编辑Banner";
    dataStore.visible = true;
    const result = await getBannerClassListReadApi(id);
    if (result?.code === 0) {
        dataStore.editRuleForm = result?.data;
    }
};
</script>

<style scoped></style>
